/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.item.Equip
 *  fire.pb.item.EquipItem
 *  fire.pb.item.ItemBase
 *  fire.pb.main.ConfigManager
 *  fire.pb.npc.SRide
 *  fire.pb.npc.SRideItem
 *  fire.pb.util.MapUtil
 *  xbean.Properties
 *  xtable.Properties
 *  xtable.Roleid2teamid
 */
package fire.pb.map;

import fire.pb.item.Equip;
import fire.pb.item.EquipItem;
import fire.pb.item.ItemBase;
import fire.pb.main.ConfigManager;
import fire.pb.map.Body;
import fire.pb.map.MapConfig;
import fire.pb.map.PEnterRegion;
import fire.pb.npc.SRide;
import fire.pb.npc.SRideItem;
import fire.pb.util.MapUtil;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicLong;
import xbean.Properties;
import xtable.Roleid2teamid;

public class Role
extends Body {
    private final long roleID;
    private AtomicInteger roadLen = new AtomicInteger();
    private AtomicInteger patrolStep = new AtomicInteger();
    private AtomicInteger huobanSize = new AtomicInteger();
    private AtomicLong lastHideBattleTick = new AtomicLong();
    private AtomicLong lastEscortBattleTick = new AtomicLong();

    Role(long roleId) {
        super(roleId, 1);
        this.roleID = roleId;
    }

    public static void getPlayerComponents(long roleid, Map<Byte, Integer> info) {
        SRide sride;
        Equip equip = new Equip(roleid, true);
        ItemBase bi = equip.getWeapon();
        if (bi != null && bi instanceof EquipItem && ((EquipItem)bi).getEndure() > 0) {
            info.put((byte)1, bi.getItemId());
            info.put((byte)7, ((EquipItem)bi).getItemAttr().equipcolor);
        } else {
            info.put((byte)1, 0);
            info.put((byte)7, 0);
        }
        bi = equip.getHeaddress();
        if (bi != null && bi instanceof EquipItem && ((EquipItem)bi).getEndure() > 0) {
            info.put((byte)2, bi.getItemId());
        }
        Properties prop = xtable.Properties.select((Long)roleid);
        int rideitemid = prop.getRide();
        int ride = 0;
        SRideItem rideitem = (SRideItem)ConfigManager.getInstance().getConf(SRideItem.class).get(rideitemid);
        if (rideitem != null && (sride = (SRide)ConfigManager.getInstance().getConf(SRide.class).get(rideitem.getRideid())) != null) {
            ride = sride.ridemodel;
        }
        info.put((byte)6, ride);
        info.put((byte)50, prop.getRolecolor1());
        info.put((byte)51, prop.getRolecolor2());
        info.put((byte)60, prop.getEquipeffect());
    }

    public long getRoleID() {
        return this.roleID;
    }

    public int getRoadLen() {
        return this.roadLen.get();
    }

    public int getPatrolStep() {
        return this.patrolStep.get();
    }

    public long getLastHideBattleTick() {
        return this.lastHideBattleTick.get();
    }

    public long getLastEscortBattleTick() {
        return this.lastEscortBattleTick.get();
    }

    public int getHuobanSize() {
        return this.huobanSize.get();
    }

    public void setRoadLen(int roadLen) {
        this.roadLen.set(roadLen);
    }

    public void setPatrolStep(int patrolStep) {
        this.patrolStep.set(patrolStep);
    }

    public void setLastHideBattleTick(long lastHideBattleTick) {
        this.lastHideBattleTick.set(lastHideBattleTick);
    }

    public void setLastEscortBattleTick(long lastEscortBattleTick) {
        this.lastEscortBattleTick.set(lastEscortBattleTick);
    }

    public void setHuobanSize(int size) {
        this.huobanSize.set(size);
    }

    @Override
    public boolean checkDistance(Body o, int distance) {
        if (!super.checkDistance(o, distance)) {
            return false;
        }
        if (o instanceof Role) {
            MapConfig mapcfg = (MapConfig)ConfigManager.getInstance().getConf(MapConfig.class).get((int)this.getScene());
            if (mapcfg == null) {
                return false;
            }
            if (mapcfg.visibletype == 1) {
                return false;
            }
            if (mapcfg.visibletype == 2) {
                Long teamid1 = Roleid2teamid.select((Long)this.getRoleID());
                Long teamid2 = Roleid2teamid.select((Long)((Role)o).getRoleID());
                if (teamid1 != null && teamid2 != null) {
                    return teamid1.equals(teamid2);
                }
                return false;
            }
        }
        return true;
    }

    @Override
    public void updateMapInfo(long sceneId, int posx, int posy, int posz) {
        long oldscene = this.getScene();
        int oldposx = this.getPos().getX();
        int oldposy = this.getPos().getY();
        super.updateMapInfo(sceneId, posx, posy, posz);
        this.enterRegion((int)oldscene, oldposx, oldposy);
        this.leaveRegion((int)oldscene, oldposx, oldposy);
    }

    private void enterRegion(int oldmapID, int oldposx, int oldposy) {
        List enterRegions = MapUtil.checkEnterRegion((int)oldmapID, (int)oldposx, (int)oldposy, (int)((int)this.getScene()), (int)this.getPos().getX(), (int)this.getPos().getY());
        if (enterRegions.isEmpty()) {
            return;
        }
        Iterator iterator = enterRegions.iterator();
        while (iterator.hasNext()) {
            int regionId = (Integer)iterator.next();
            new PEnterRegion(this.roleID, regionId).submit();
        }
    }

    private void leaveRegion(int oldmapID, int oldposx, int oldposy) {
        List leaveRegions = MapUtil.checkLeaveRegion((int)oldmapID, (int)oldposx, (int)oldposy, (int)((int)this.getScene()), (int)this.getPos().getX(), (int)this.getPos().getY());
        if (leaveRegions.isEmpty()) {
            return;
        }
    }

    public boolean isInRegion(int regionId) {
        return MapUtil.isInRegion((int)((int)this.getScene()), (int)this.getPos().getX(), (int)this.getPos().getY(), (int)regionId);
    }

    public boolean isInRegion2(int regionId) {
        return MapUtil.isInRegion2((int)((int)this.getScene()), (int)this.getPos().getX(), (int)this.getPos().getY(), (int)regionId);
    }

    public MapConfig getCurMapConfig() {
        return (MapConfig)ConfigManager.getInstance().getConf(MapConfig.class).get(this.getMapId());
    }
}

